//////////////////////////////////////////////////////
//CMyOleDropTarget - implementation file

#include "stdafx.h"
#include "MyTarget.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CMyOleDropTarget::CMyOleDropTarget(){
    m_pInfo = new SDropInfo;
}
CMyOleDropTarget::~CMyOleDropTarget(){
    if(m_pInfo!=NULL)
        delete m_pInfo;
}
DROPEFFECT CMyOleDropTarget::OnDragOver(CWnd* pWnd, 
                                        COleDataObject* pDataObject,
                                        DWORD dwKeyState,
                                        CPoint point){
    ASSERT(m_pInfo!=NULL);

    if (pWnd->IsKindOf(RUNTIME_CLASS(CView)))
        return COleDropTarget::OnDragOver(pWnd, pDataObject, 
                                          dwKeyState, point);

    m_pInfo->point.x = point.x;
    m_pInfo->point.y = point.y;
    m_pInfo->pOleObj = pDataObject;
    m_pInfo->KeyState = dwKeyState;

    return (pWnd->SendMessage(WM_DRAGOP,DRAGOP_DRAGOVER,
                                (LPARAM)m_pInfo));
}
BOOL CMyOleDropTarget::OnDrop( CWnd* pWnd, 
                               COleDataObject* pDataObject, 
                               DROPEFFECT dropEffect, 
                               CPoint point ){
    if (pWnd->IsKindOf(RUNTIME_CLASS(CView)))
        return COleDropTarget::OnDrop(pWnd, pDataObject, 
                                        dropEffect, point);

    m_pInfo->point.x = point.x;
    m_pInfo->point.y = point.y;
    m_pInfo->pOleObj = pDataObject;
    m_pInfo->d_effect = dropEffect;
    
    return (BOOL)(pWnd->SendMessage(WM_DRAGOP,DRAGOP_DROP,
                                    (LPARAM)m_pInfo));
}
DROPEFFECT CMyOleDropTarget::OnDragEnter(CWnd* pWnd, 
                                         COleDataObject* pDataObject, 
                                         DWORD dwKeyState, 
                                         CPoint point ){
    if (pWnd->IsKindOf(RUNTIME_CLASS(CView)))
        return COleDropTarget::OnDragEnter(pWnd, pDataObject, 
                                            dwKeyState, point);

    m_pInfo->d_effect = DROPEFFECT_NONE;
    m_pInfo->point.x = point.x;
    m_pInfo->point.y = point.y;
    m_pInfo->pOleObj = pDataObject;

    return (DROPEFFECT)(pWnd->SendMessage(WM_DRAGOP,
                           DRAGOP_ENTER,(LPARAM)m_pInfo));
}
void CMyOleDropTarget::OnDragLeave(CWnd *pWnd){
    if (pWnd->IsKindOf(RUNTIME_CLASS(CView))){
        COleDropTarget::OnDragLeave(pWnd);
        return;
    }
    pWnd->SendMessage(WM_DRAGOP,DRAGOP_LEAVE);
}

